VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Fun With Textboxes"
   ClientHeight    =   5076
   ClientLeft      =   60
   ClientTop       =   348
   ClientWidth     =   2952
   Icon            =   "Textbox Fun.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   5076
   ScaleWidth      =   2952
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtNumbers 
      Height          =   375
      Left            =   240
      TabIndex        =   10
      Text            =   "Enter Numbers"
      Top             =   4560
      Width           =   2415
   End
   Begin VB.TextBox txtLabel 
      Height          =   375
      Left            =   240
      TabIndex        =   8
      Tag             =   "Enter Data Here"
      Text            =   "Enter Data Here"
      Top             =   3720
      Width           =   2415
   End
   Begin VB.TextBox txtReverse 
      Height          =   375
      Left            =   240
      TabIndex        =   6
      Text            =   "ESREVER"
      Top             =   2880
      Width           =   2415
   End
   Begin VB.TextBox txtHighlight 
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Text            =   "Highlighted On Entry"
      Top             =   2040
      Width           =   2415
   End
   Begin VB.TextBox txtToggle 
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Text            =   "Toggle Me"
      Top             =   1200
      Width           =   2415
   End
   Begin VB.TextBox txtOvertype 
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Text            =   "Overtype Me"
      Top             =   360
      Width           =   2415
   End
   Begin VB.Label lblNumbers 
      Caption         =   "Numbers Only"
      Height          =   252
      Left            =   240
      TabIndex        =   11
      Top             =   4320
      Width           =   2172
   End
   Begin VB.Label lblLabel 
      Caption         =   "The Textbox Is The Label"
      Height          =   255
      Left            =   240
      TabIndex        =   9
      Top             =   3480
      Width           =   2415
   End
   Begin VB.Label lblReverse 
      Caption         =   "Reverse Text As You Type It"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   2640
      Width           =   2415
   End
   Begin VB.Label lblHighlight 
      Caption         =   "Highlight Contents on Entry"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   1800
      Width           =   2415
   End
   Begin VB.Label lblToggle 
      Caption         =   "Toggle Overtype with Insert Key"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   960
      Width           =   2415
   End
   Begin VB.Label lblOvertype 
      Caption         =   "Overtype Mode"
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   2175
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Create a flag to track the state of insert key
Private bOvertype As Boolean

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
'Toggle overtype mode if insert key is pressed and released
If KeyCode = vbKeyInsert Then bOvertype = Not bOvertype
'You could provide a visual indicator of the state
'like this or in a status bar
If bOvertype = True Then
    lblToggle.BackColor = vbGreen
Else
    lblToggle.BackColor = Form1.BackColor
End If
End Sub

Private Sub Form_Load()
'Initialize to default insert mode, no overtype
bOvertype = False
End Sub

Private Sub Text1_Change()

End Sub

Private Sub Text1_GotFocus()

End Sub

Private Sub txtHighlight_GotFocus()
'Make sure insertion point is at start even if you click in
txtHighlight.SelStart = 0
'Highlight based on length of existing text
txtHighlight.SelLength = Len(txtHighlight.Text)
'This could go in a common function called using "ActiveControl"
'so the code doesn't have to be written in every textbox where it's needed
End Sub

Private Sub txtLabel_GotFocus()
ActiveControl.SelStart = 0
ActiveControl.SelLength = Len(ActiveControl.Text)

End Sub

Private Sub txtLabel_LostFocus()
'Check for blank or spaces
'If nothing has been entered, restore
'the default text from the tag property
If Trim(txtLabel.Text) = "" Then
    txtLabel.Text = txtLabel.Tag
End If
End Sub

Private Sub txtNumbers_GotFocus()
'These two lines highlight the text on entry
txtNumbers.SelStart = 0
txtNumbers.SelLength = Len(txtNumbers.Text)
End Sub

Private Sub txtNumbers_KeyPress(KeyAscii As Integer)
If KeyAscii < 48 Or KeyAscii > 57 Then
    KeyAscii = 0
End If
End Sub

Private Sub txtOvertype_KeyPress(KeyAscii As Integer)
'Select the next character in the textbox so it gets overwritten
txtOvertype.SelLength = 1
End Sub

Private Sub txtReverse_KeyPress(KeyAscii As Integer)
'Put the insertion point at the beginning on every key press
txtReverse.SelStart = 0
End Sub

Private Sub txtToggle_KeyPress(KeyAscii As Integer)
'Overtype only if the correct state has been established
If bOvertype = True Then txtToggle.SelLength = 1
End Sub
